#include "port.h"
#include "utility.h"
#include "fang.h"
#include "fa_internal.h"

/*LINTLIBRARY*/

void fa_frame(geo, grow, shrink, outgeo)
fa_geometry *geo;
int grow, shrink;
fa_geometry *outgeo;
{
    fa_geometry ngeo;

    fa_grow(geo, grow, &ngeo);
    fa_grow(&ngeo, -shrink, outgeo);
    fa_free_geo(&ngeo);

    if (fa_debug) {
	(void) fprintf(stderr, "after grow :\n");
	fa_dump_vertices(outgeo->head);
    }
}
void fa_frame_xy(geo, grow, shrink, direction, outgeo)
fa_geometry *geo;
int grow, shrink;
int direction;
fa_geometry *outgeo;
{
    fa_geometry ngeo;

    fa_grow_xy(geo, grow, direction, &ngeo);
    fa_grow_xy(&ngeo, -shrink, direction, outgeo);
    fa_free_geo(&ngeo);

    if (fa_debug) {
	(void) fprintf(stderr, "after grow :\n");
	fa_dump_vertices(outgeo->head);
    }
}
