/*
 * File completion testing program.
 */

#include "port.h"
#include "fc.h"

char optProgName[] = "fc_test";

#define Fprintf		(void) fprintf
#define Printf		(void) printf

main(argc, argv)
int argc;
char *argv[];
/*
 * Format: fc_test file
 * Prints possible completions to standard output.
 */
{
    char **list;
    int count, start, span;

    if (argc != 2) {
	Fprintf(stderr, "format: %s file\n", argv[0]);
	exit(1);
    }
    list = fc_complete(argv[1], &start, &span);
    if (list) {
	count = 0;
	while (*list) {
	    Printf("%s\n", *list);
	    list++;
	    count++;
	}
	Printf("%d completions (start = %d, span = %d).\n", count, start, span);
    } else {
	Printf("no completions.\n");
    }
    exit(0);
}
