#include "port.h"
#include "utility.h"
#include "errtrap.h"
#include "oct.h"
#include "oh.h"
#include "nle.h"

/* open chip, get the bag "NLE_BAG", and merge the cells inside */

/*ARGSUSED*/
main(argc,argv)
int argc;
char **argv;
{
  octObject Bag, NewChip, Chip, NewInstance;
  char *input_cell, *input_view;

  /* parse command line options*/

  /* XXX ohUnpackFacetName */

  input_cell = util_strsav(argv[1]);
  input_view = strchr(input_cell, ':');
  if (input_view != (char *) 0) {
    *input_view++ = '\0';
  } else {
    input_view = "symbolic";
  }

  Chip.type = OCT_FACET;
  Chip.contents.facet.cell = input_cell;
  Chip.contents.facet.view = input_view;
  Chip.contents.facet.facet = "contents";
  Chip.contents.facet.version = OCT_CURRENT_VERSION;
  Chip.contents.facet.mode = "a";

  OH_ASSERT(octOpenFacet(&Chip));
  
  OH_ASSERT(ohGetByBagName(&Chip, &Bag, "NLE_BAG"));

  NewChip.type = OCT_FACET;
  NewChip.contents.facet.cell = "new";
  NewChip.contents.facet.view = "symbolic";
  NewChip.contents.facet.facet = "contents";
  NewChip.contents.facet.version = OCT_CURRENT_VERSION;
  NewChip.contents.facet.mode = "a";

  OH_ASSERT(octOpenFacet(&NewChip));
  OH_ASSERT(octFlushFacet(&NewChip));	/* commit */

  (void) nleMakeMacro(&NewChip, &Bag, &NewInstance, NLE_HARD);

  /* (void) nleFlatInstance(&NewInstance, &Bag, NLE_HARD); */

  OH_ASSERT(octCloseFacet(&Chip)); 
  OH_ASSERT(octCloseFacet(&NewChip)); 

  exit(0);
}

