#ifndef OCT_GEO_H
#define OCT_GEO_H

#define GEO_FIELDS GENERIC_FIELDS

struct geo {
    GEO_FIELDS;
};

struct box {
    GEO_FIELDS;
    struct octBox user_box;
};

struct label {
    GEO_FIELDS;
    struct octLabel user_label;
};

struct point {
    GEO_FIELDS;
    struct octPoint user_point;
};

struct edge {
    GEO_FIELDS;
    struct octEdge user_edge;
};

struct circle {
    GEO_FIELDS;
    struct octBox bbox;
    struct octCircle user_circle;
};

#define GEO_POINTS_FIELDS \
    GEO_FIELDS;\
    struct octBox bbox;\
    int32 num_points;\
    struct octPoint *points

struct geo_points {
    GEO_POINTS_FIELDS;
};

struct path {
    GEO_POINTS_FIELDS;
    struct octPath user_path;
};

struct polygon {
    GEO_POINTS_FIELDS;
};

struct change_record {
    GEO_POINTS_FIELDS;
    int object_type;
    struct octChangeRecord user_change_record;
    octObject *old_value;
};

#endif /* OCT_GEO_H */
