/*
 * Contact Maintenence
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * Exported definitions from contact.c.
 */

#ifndef _CONTACT_H_
#define _CONTACT_H_

#include "ansi.h"
#include "oct.h"
#include "tap.h"

extern int symContactP
  ARGS((octObject *obj));
  /* Returns a non-zero status if `obj' is a connector or connector terminal */

#define SYM_MAX_MSG	2048

typedef struct sym_con_func_defn {
    int (*func)			/* Function to call            */
      ARGS((int nLayers, tapLayerListElement *layerList,
	    octObject *instance, char why[SYM_MAX_MSG],
	    char *data));
    char *data;			/* User data passed to function */
} symConFunc;

extern symConFunc *symDefConFunc;
   /* Exported default connector function */

extern void symAddToConnectorsBag
  ARGS((octObject *connector));
  /* Adds an instance to the connectors bag for the facet */

extern void symConnector
  ARGS((octObject *parent, octCoord x, octCoord y,
	int ne, tapLayerListElement elems[], symConFunc *confun,
	octObject *connector));
  /* Makes a new connector */

extern int symUpgrade
  ARGS((octObject *term, tapLayerListElement *elem, symConFunc *confun,
	octObject *new_conn));
  /* Examines connector terminal for possible upgrade */

#endif /* _CONTACT_H_ */
