/*
 * Copying a set of objects in symbolic
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * Exported definitions for the copy primitives.
 */

#ifndef _COPY_H_
#define _COPY_H_

#include "ansi.h"
#include "contact.h"
#include "oct.h"

/*
 * Copy a set of objects
 */

typedef struct sym_copy_item_defn {
    void (*func)		/* Function to call */
      ARGS((octObject *old, octObject *new, char *data));
    char *data;			/* User supplied data */
} symCopyItemFunc;

extern void symCopyObjects
  ARGS((octObject *facet, octObject *set, struct octTransform *transform,
	octObject *result, symConFunc *confun, symCopyItemFunc *ci));


#endif /* _COPY_H_ */
