/*
 * Formal Terminal Maintenence
 *
 * David Harrison
 * University of California, Berkeley
 * 1988
 *
 * This file contains an implementation of the symbolic formal
 * terminal command.
 */

#ifndef _FORMAL_H_
#define _FORMAL_H_

#include "ansi.h"

typedef struct sym_term_func_defn {
    void (*func)		/* Function to call */
      ARGS((octObject *fterm, octObject *obj, int detach, char *data));
    char *data;			/* User data        */
} symTermFunc;

extern void symNewFormal
  ARGS((octObject *facet, octObject *fterm, octObject *implBag,
	char *termtype, char *termdir, symTermFunc *term_func));
  /* Creates a new symbolic formal terminal */

#define SYM_TERM_TYPE	"TERMTYPE"
#define SYM_TERM_DIR	"DIRECTION"

extern int symGetTermProp
  ARGS((octObject *term, octObject *prop));
  /* Finds property annotations on formal terminals */

#endif /* _FORMAL_H_ */
