/*
 * Net Manipulation
 * 
 * David Harrison
 * University of California, Berkeley
 * 1989
 *
 * This file contains definitions for using the net merging routines
 * in net.c
 */

#ifndef _NET_H_
#define _NET_H_

#include "ansi.h"
#include "oct.h"

typedef struct sym_merge_func_defn {
    int (*func)			/* Function to call */
      ARGS((octObject *net1, octObject *net2, char *data));
    char *data;			/* User data        */
} symMergeFunc;

extern void symSetMergeFunc
  ARGS((symMergeFunc *new, symMergeFunc *old));
  /* Set the merging function */

extern octObject *symMergeNets
  ARGS((octObject *first, octObject *second));
  /* Merge two nets into one */

extern int symBreakNet
  ARGS((octObject *obj, octObject *net, octObject *new_net, int warn_p));
  /* Removes portion of `net' connected to `obj' */

extern int symLocNet
  ARGS((octObject *obj, octObject *net));
  /* Finds net associated with object */

extern void symCreateNamedNet
  ARGS((octObject *obj, octObject *net));
  /* Creates new machine named net in same facet as `obj' */

extern int symHumanNamedNetP
  ARGS((octObject *net));
  /* Returns non-zero if net is human named */

extern void symNetRemove
  ARGS((octObject *net));
  /* Removes net with clean-up */

#endif /* _NET_H_ */
