#include "copyright.h"
#include "port.h"
#include "vov.h"
#include "utility.h"
#include "oct.h"
#include "errtrap.h"

static char* facet_fullname(facet)
    octObject* facet;
/*
* A small utility to get the full name of a facet.
* protect it if the objectId is not valid.
*/
{
    char* fullname = facet->contents.facet.cell; /* Default */
    octObject tmpFacet;
    tmpFacet.objectId = facet->objectId;
    if ( octGetById( &tmpFacet ) == OCT_OK ) {	 /* If ID is good,.. */
	if ( tmpFacet.type == OCT_FACET ) {	 /* Make sure it is a facet. */
	    if ( strcmp( fullname, tmpFacet.contents.facet.cell ) == 0 ) {
		octFullName( &tmpFacet, &fullname);	 /* Only now get the full name. */
	    }
	}
    } 
    return fullname;
}


int VOVinputFacet( facet )
    octObject* facet;
{
    if ( ! libActive(0) ) return 0;
    {
	char buf[1024];
	sprintf( buf, "%s:%s:%s", 
		facet_fullname(facet),
		facet->contents.facet.view ,
		facet->contents.facet.facet );
	return VOVinput( VOV_OCT_FACET, buf );
    }
}

int VOVoutputFacet( facet )
    octObject* facet;
{
    if ( ! libActive(0) ) return 0;
    {
	char buf[1024];
	sprintf( buf, "%s:%s:%s", 
		facet_fullname(facet),
		facet->contents.facet.view ,
		facet->contents.facet.facet );
	return VOVoutput( VOV_OCT_FACET, buf );
    }
}





